More user-friendly version of this [youtube-comment-downloader](https://github.com/egbertbouman/youtube-comment-downloader). 

This fork adds and plans to add:

- [x] Default filenames so no -o is needed
- [x] Full URL support for the -y argument so no manual ID extracting is needed
- [x] Better error handling - more user-friendly errors
- [x] Add option to output valid JSON array instead of line-delimited JSON for easier parsing (-a)
- [x] Isolate download function so it can be easily called from other python files
- [x] Downloading comments for all urls in file (generated by youtube-dl)
  - [x] Option to change download dir for batch-downloaded comments
- [ ] Fetching video name with system youtube-dl instalation?

Beware that I don't know how to use python so this may not be the cleanest code

(almost) original description:

# youtube-comment-downloader

Simple script for downloading Youtube comments without using the Youtube API. The output is in JSON.

### Installation

Preferably inside a [python virtual environment](https://virtualenv.pypa.io/en/latest/) install this package via

```
pip install https://github.com/qespr/youtube-comment-downloader/archive/master.zip
```

### Usage

```
$ youtube-comment-downloader --help
usage: downloader.py [--help] [--youtubeid YOUTUBEID] [--file FILE] [--output OUTPUT] [--limit LIMIT] [--sort SORT]

Download Youtube comments without using the Youtube API

optional arguments:
  --help, -h            Show this help message and exit
  --youtubeid YOUTUBEID, -y YOUTUBEID
                        ID or URL of Youtube video for which to download the comments
  --file FILE, -f FILE  File of names and IDs or URLs to download comments for
  --output OUTPUT, -o OUTPUT
                        Change output file (or directory if -f is specified) format is line delimited JSON unless (-a specified)
  --array, -a           Output to JSON array instead of line delimited JSON
  --limit LIMIT, -l LIMIT
                        Limit the number of comments - applies globaly if file -f is specified
  --sort SORT, -s SORT  Whether to download popular (0) or recent comments (1). Defaults to 1
```

For example:

```
youtube-comment-downloader --youtubeid ScMzIvxBSi4 --output ScMzIvxBSi4.json
```

For Youtube IDs starting with - (dash) you will need to run the script with:
`-y=-idwithdash` or `--youtubeid=-idwithdash`
(or use the full video URL)

Syntax for -f or --file file is like this:

```
video name
videoID
```

if this file will be passed to -f or --file then comments will be downloaded for every video and resulting json will be saved to "./video name.json" all ilegal characters will
be automatically stripped and replaced with "-" by the script to not cause any problems on NTFS.

This file can be generated automatically using youtube-dl like this:

```
youtube-dl --get-id --get-title  https://www.youtube.com/playlist?list=someListId > someFile.txt
```

### Dependencies

* Python 2.7+
* requests

The python packages can be installed with:

    pip install -r requirements.txt
